#!/bin/sh

if [ $# -lt 1 ]
then
	exit 1
fi

GAMEDIR="$1"
CWD=$(pwd)

if [ -d "$CWD/$GAMEDIR/mapsrc/" ]
then
	OLDDIR="$(pwd)"
	
	find "$GAMEDIR/mapsrc/" -name "*.map" | while read QEDMAP
	do
		cd "$(dirname "$QEDMAP")"
		MAPFILE="$(basename "$QEDMAP")"
		LD_LIBRARY_PATH="$CWD" PATH="$PATH:$OLDDIR" qbsp  -wadpath "$CWD/$GAMEDIR" "$MAPFILE"
		LD_LIBRARY_PATH="$CWD" PATH="$PATH:$OLDDIR" qvis "$MAPFILE"
		LD_LIBRARY_PATH="$CWD" PATH="$PATH:$OLDDIR" qrad -extra4 "$MAPFILE"
		cd "$OLDDIR"
	done
	
	find "$GAMEDIR/mapsrc/" -name "*.bsp" | while read MAPFILE
	do
		NEWPATH="$(echo "$MAPFILE" | sed 's/\/mapsrc\//\/maps\//g')"
		NEWPATHDIR=$(dirname "$NEWPATH")
		mkdir -p "$NEWPATHDIR"
		mv -v "$MAPFILE" "$NEWPATH"
	done
	
	find "$GAMEDIR/mapsrc/" -name "*.lit" | while read MAPFILE
	do
		NEWPATH="$(echo "$MAPFILE" | sed 's/\/mapsrc\//\/maps\//g')"
		NEWPATHDIR=$(dirname "$NEWPATH")
		mkdir -p "$NEWPATHDIR"
		mv -v "$MAPFILE" "$NEWPATH"
	done
fi
