#!/bin/sh

if [ $# -lt 1 ]
then
	exit 1
fi

CWD="$(pwd)"
GAMEDIR="$1"
TARGET="$2"
MAPFILE=$(echo "$TARGET" | sed 's/\.bsp/\.map/g' | sed 's/\/maps\//\/mapsrc\//g')
MAPOUT=$(echo "$TARGET" | sed 's/\/maps\//\/mapsrc\//g')
LITOUT=$(echo "$TARGET" | sed 's/\.bsp/\.lit/g')
LITFILE=$(echo "$TARGET" | sed 's/\.bsp/\.lit/g' | sed 's/\/maps\//\/mapsrc\//g')
OLDDIR="$(pwd)"

if [ -d "$CWD/$GAMEDIR/mapsrc/" ]
then
	cd "$(dirname "$MAPFILE")"
	MAPFILE="$(basename "$MAPFILE")"
	PATH="$PATH:$OLDDIR" qbsp -wadpath "$CWD/$GAMEDIR" "$MAPFILE"
	PATH="$PATH:$OLDDIR" qvis "$MAPFILE"
	PATH="$PATH:$OLDDIR" qrad -extra4 "$MAPFILE"
	cd "$OLDDIR"
	mv -v "$MAPOUT" "$TARGET"
	mv -v "$LITFILE" "$LITOUT" 
fi
